﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindDetailsView();
        }
    }

    private void BindDetailsView()
    {
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand("SELECT CustomerId, Name, Country FROM Customers", con))
            {
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    using (DataTable dt = new DataTable())
                    {
                        sda.Fill(dt);
                        DetailsView1.DataSource = dt;
                        DetailsView1.DataBind();
                    }
                }
            }
        }
    }

    protected void OnItemCreated(object sender, EventArgs e)
    {
        int commandRowIndex = DetailsView1.Rows.Count - 1;
        if (commandRowIndex != -1)
        {
            DetailsViewRow row = DetailsView1.Rows[commandRowIndex];
            Button btnDelete = row.Controls[0].Controls.OfType<Button>().Where(b => b.CommandName == "Delete").FirstOrDefault();
            btnDelete.Attributes["onclick"] = "if(!confirm('Do you want to delete this Customer?')){ return false; };";
        }
    }

    protected void OnItemDeleting(object sender, DetailsViewDeleteEventArgs e)
    {
        int customerId = int.Parse(DetailsView1.Rows[0].Cells[1].Text);
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        using (SqlConnection con = new SqlConnection(constr))
        {
            using (SqlCommand cmd = new SqlCommand("DELETE FROM Customers WHERE CustomerId = @CustomerId", con))
            {
                cmd.Parameters.AddWithValue("@CustomerId", customerId);
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
            }
        }
        this.BindDetailsView();
    }

    protected void OnPageIndexChanging(object sender, DetailsViewPageEventArgs e)
    {
        DetailsView1.PageIndex = e.NewPageIndex;
        this.BindDetailsView();
    }
}